﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;

namespace VoteApp.Models
{
    public class VoteSystem
    {
        public int SystemId { get; set; }
        public string SystemName { get; set; }

        public List<VoteSystem> SystemList(string connectionString)
        {

            List<VoteSystem> systemList = new List<VoteSystem>();

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select VoteSystemId, VoteSystemName from VOTE_SYSTEM order by VoteSystemName";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    VoteSystem system = new VoteSystem();

                    system.SystemId = Convert.ToInt32(dr["VoteSystemId"]);
                    system.SystemName = dr["VoteSystemName"].ToString();

                    systemList.Add(system);
                }

            }

            return systemList;
        }

        public string GetSystemName(string connectionString, int voteSystemId)
        {
            string systemName = null;

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select VoteSystemName from VOTE_SYSTEM where VoteSystemId=" + voteSystemId;

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    systemName = dr["VoteSystemName"].ToString();
                }
            }

            return systemName;
        }

        public VoteSystem GetSystemData(string connectionString, int voteSystemId)
        {
            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select VoteSystemId, VoteSystemName from VOTE_SYSTEM where VoteSystemId=" + voteSystemId;

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            VoteSystem voteSystem = new VoteSystem();

            if (dr != null)
            {
                while (dr.Read())
                {
                    voteSystem.SystemId = Convert.ToInt32(dr["VoteSystemId"]);
                    voteSystem.SystemName = dr["VoteSystemName"].ToString();
                }
            }

            return voteSystem;
        }

        public void CreateSystem(string connectionString, VoteSystem voteSystem)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("CreateVoteSystem", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@VoteSystemName", voteSystem.SystemName));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

        }

        public void EditSystem(string connectionString, VoteSystem voteSystem)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("UpdateVoteSystem", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@VoteSystemId", voteSystem.SystemId));
                    cmd.Parameters.Add(new SqlParameter("@VoteSystemName", voteSystem.SystemName));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

        }

        public void DeleteSystem(string connectionString, int systemId)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("DeleteVoteSystem", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@VoteSystemId", systemId));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

        }


    }
}
