using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Mvc.RazorPages;
using VoteApp.Models;

namespace VoteApp.Pages
{
    public class NewSystemModel : PageModel
    {
        readonly IConfiguration _configuration;

        private string connectionString;

        public int login = 0;
        public const string SessionKeyLogin = "_Login";
        public string SessionInfo_Login { get; private set; }

        public NewSystemModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            VerifyLogin();

            GetSessionData();
        }

        public void OnPost()
        {
            VerifyLogin();

            GetSessionData();

            SaveSystemData();
        }

        void SaveSystemData()
        {
            if (login == 2)
            {
                VoteSystem voteSystem = new VoteSystem();

                voteSystem.SystemName = Request.Form["SystemName"];

                connectionString = _configuration.GetConnectionString("ConnectionString");

                voteSystem.CreateSystem(connectionString, voteSystem);

                Response.Redirect("./ConfigureSystems");
            }
            else
                Response.Redirect("./Error");

        }

        void GetSessionData()
        {
            if (!string.IsNullOrEmpty(HttpContext.Session.GetString(SessionKeyLogin)))
                login = (int)HttpContext.Session.GetInt32(SessionKeyLogin);
        }


        private void VerifyLogin()
        {
            if (!string.IsNullOrEmpty(HttpContext.Session.GetString(SessionKeyLogin)))
                login = (int)HttpContext.Session.GetInt32(SessionKeyLogin);

            if (login != 2)
                Response.Redirect("./Error");
        }
    }
}
